
//However, older sketches often have direct interrupt numbers. Often number 0 (for digital pin 2) or number 1 (for digital pin 3) were used. The table below shows the available interrupt pins on various boards.
#include <DFRobot_RGBLCD.h>

int URECHO = 10;         // PWM Output 0-25000US,Every 50US represent 1cm
int URTRIG = 11;         // trigger pin
unsigned int DistanceMeasured = 0;

const int trigger_pin = 2;
const int reset_pin = 3;
const int clipper_pin = 8;
int sensorVal = 0;
int distance;
bool hit_flag = false;
bool ready_flag = false;
unsigned long pre_time;
unsigned long now;
unsigned long time_count = 0;

unsigned int lcd_r = 0, lcd_g = 0, lcd_b = 0;
unsigned long delaytime = 0, lighttime = 0;
DFRobot_RGBLCD lcd(16, 2);

void setup() {
  //start serial connection
  lcd.init();
  delay(5000);
  Serial.begin(9600);
  pinMode(URTRIG, OUTPUT);                   // A low pull on pin COMP/TRIG
  digitalWrite(URTRIG, HIGH);                // Set to HIGH
  pinMode(URECHO, INPUT);

  pinMode(clipper_pin, INPUT_PULLUP);
  pinMode(trigger_pin, INPUT);
  attachInterrupt(0, hit_detection_func, CHANGE);//Often number 0 (for digital pin 2)，digitalPinToInterrupt(trigger_pin)
  attachInterrupt(1, reset_func, CHANGE);//Often number 0 (for digital pin 2)，digitalPinToInterrupt(trigger_pin)
  sensorVal = digitalRead(clipper_pin);
  if (sensorVal == 0) {
    Serial.println("初始化完成，请按下准备键");
  } else {
    Serial.println("初始化完成，请放置钢珠后，并按下准备键");
  }
}

void loop() {

  if (ready_flag == true) {
    // with metal ball - sensor val = 0
    // release ball
    // no metal ball - sensor val = 1
    sensorVal = digitalRead(clipper_pin);
    if (sensorVal == 1 && hit_flag == false) { // release the ball
      pre_time = micros();
      while (hit_flag == false) {
        Serial.print("-");
        //delay(1);
      }
      now = micros();
      Serial.println();
      time_count = now - pre_time;
      Serial.println(distance);
      Serial.println(time_count / 1000000.0, 6);
      ready_flag = false;
    }
  }
  else
  {
    lcd.setCursor(0, 0);
    lcd.print("Dis:");
    lcd.setCursor(4, 0);
    lcd.print(distance);
    lcd.setCursor(7, 0);
    lcd.print("cm");
    lcd.setCursor(0, 1);
    lcd.print("Time:");
    lcd.setCursor(6, 1);
    if (time_count / 1000000) { //落地时间大于1s
      lcd.print(time_count / 1000000);
    } else {
      lcd.print(0);
    }
    lcd.print('.');
    lcd.print(time_count / 100000 % 10);
    lcd.print(time_count / 10000 % 10);
    lcd.print(time_count / 1000 % 10);
    lcd.print(time_count / 100 % 10);
    lcd.print(time_count / 10 % 10);
    lcd.print(time_count % 10);
    lcd.print('s');
  }

}



void hit_detection_func() {
  hit_flag = true;
  //Serial.println("Triggered");
}

void reset_func() {
  sensorVal = digitalRead(clipper_pin);
  if (sensorVal == 0) {
    hit_flag = false;
    distance = get_distance();
    //Serial.print("height:");
    //Serial.println(distance);
    Serial.println("已准备，请释放钢珠");
    //    lcd.clear();
    //    lcd.setRGB(0, 255, 0);
    //    lcd.setCursor(0, 0);
    //    lcd.print("Release the ball");
    //    delay(500);
    ready_flag = true;
  } else {
    Serial.println("请放置钢珠");
    //    lcd.clear();
    //    lcd.setCursor(0, 0);
    //    lcd.setRGB(255, 255, 0);
    //    lcd.print("Reset the ball");
    //    delay(500);
  }
}

unsigned int get_distance() {
  digitalWrite(URTRIG, LOW);
  digitalWrite(URTRIG, HIGH);

  unsigned long LowLevelTime = pulseIn(URECHO, LOW) ;
  if (LowLevelTime >= 50000)              // the reading is invalid.
  {
    Serial.println("Invalid");
    return 0;
  }
  else
  {
    DistanceMeasured = LowLevelTime / 50;  // every 50us low level stands for 1cm
    //Serial.print(DistanceMeasured);
    //Serial.println("cm");
    return DistanceMeasured;
  }

}
